<script type="text/javascript">
	/*globals RED */
	RED.nodes.registerType('Storage Admin', {
		category: 'storage',
		color: '#fdeea2',
		defaults: {
			name: {value:null},
			storageDefinition: {type:"Storage Definition"},
			action: {value:"payload"},"action-type": {value:"msg"}
		},
		inputs: 1,
		outputs: 2,
		icon: "font-awesome/fa-wrench",
		align: 'left',
		paletteLabel: "Storage Admin",
		inputLabels: "Message In",
		outputLabels: ["OK","Error"],
		label: function () {
			const name=RED.nodes.node(this.storageDefinition).name;
			return this.name ||"Storage Admin "+ (name||this.storageDefinition);
		},
		oneditprepare: function() {
			const node=this;
			node.properties=[];
			node.editors=[];
			const actions={
//				blockStorage:{label:"Block Storage",show:["fileName"],args:[]}
			};
			const baseDiv=$("#node-inputDynamicBase");
			function defineProperty(property,...types) {
				const element=$('<div/>',{ "class": "form-row form-row-http-in-"+property.name+" hide" }).append(
    				 	$('<label for="node-input-'+property.name+'" style="white-space: nowrap"><i class="fa fa-'+(property.icon||'bookmark')+'"></i> '+property.label+'</label>'),
					);
				element.appendTo(baseDiv);
				node.properties.push(property.name);
				if(types[0]=="edit") {
					element.append($('<div style="height: 250px; min-height:150px;" class="node-text-editor" id="node-input-'+property.name+'-editor"></div>'));
					node.editors[property.name] = RED.editor.createEditor({
   						id: 'node-input-'+property.name+'-editor',
   						mode: 'ace/mode/'+property.mode||"text",
   						value: node[property.name]||property.default
					});
				} else {
					const inputNode=$('<input type="text" id="node-input-'+property.name+'"/>').val(node[property.name]);
					const typeNode=$('<input type="hidden" id="node-input-'+property.name+'-type"/>');
					element.append([inputNode,typeNode]);
					const typeValue=node[property.name+"-type"];
					if(typeValue) typeNode.val(typeValue);
					$("#node-input-"+property.name).typedInput({
	  					type:typeValue||types[0],
    					types:types,
    					typeField: "#node-input-"+property.name+"-type"
					});
				}
			}
			defineProperty({name:"action"				,label:"Action"	,icon:"tag"},"str","msg");
			["action"].forEach(property=>$(".form-row-http-in-"+property).show());
/*
			const options=Object.keys(actions).reduce((previousValue,property)=>previousValue.concat({value:property,label:actions[property].label}),
				[]);
			const actionNode=$("#node-input-action");
			actionNode.typedInput({
    			types: [{
            		value: "actionType",
            		options: options
				}]
			});
			actionNode.change(function() {
				action=$(this).val();
				node.args=[];
				node.properties.forEach(property=>$(".form-row-http-in-"+property).hide());
				const actionDef=actions[action];
				node.args=actionDef.args;
				node.args.forEach(property=>$(".form-row-http-in-"+property).show());
				actionDef.show.forEach(property=>$(".form-row-http-in-"+property).show());

			});
*/
		},
		oneditsave: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
				node[property]=editor.getValue();
	    		editor.destroy();
    			delete editor;
			})
		},
		oneditcancel: function() {
			const node=this;
			Object.keys(node.editors).forEach(property=>{
				const editor=node.editors[property];
    			editor.destroy();
    			delete editor;
			});
		},
		resizeRule: function(file,newWidth) {
		},
		button: {
			enabled: function() {return !this.changed;},
			onclick: function() {
//				if(this.changed) return RED.notify(RED._("Queue undeployed changes"),"warning");
				let label=this._def.label.call(this);
				if(label.length>30) label=label.substring(0,50)+"...";
				label=label.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
				const node=this;
/*
				function listTopic(node,topics,float,add) {
					float.html("<table id='activeTopics'><tr><th>Action</th><th>Topic</th><th>partition</th>"+(add?"<th>offset</th>":"")+"<tr></table>");
					const activeTopicsElements=$('#activeTopics')
					topics.forEach((r)=>addTopic(float,activeTopicsElements,r.topic,r.partition,r.offset||0,add));
				}
				function addTopic(float,activeTopicsElements,topic,partition,offset=0) {
					const row=$('<tr/>').appendTo(activeTopicsElements);
					const deleteButton=$('<a/>',{href:"#",class:"editor-button editor-button-medium"}).appendTo(row);
					$('<i/>',{class:"fa fa-remove"})//.appendTo(deleteButton);
					deleteButton.click(function() {
						sendCommand(float,"removeTopic",{topics:[{topic:topic,partition:partition}]});				
					});
				}
				function confirm(element,action,titleSuffix,data) {
					$(element).remove();
					constfloat=float(titleSuffix||action,"<input id='inputTopics' type='text' size='100'/>",
						{
							OK: ()=>sendCommand(this,action,data),
							Cancel: ()=>$(this).remove()
						}
					)
				}
*/				
				function float(titleSuffix="",html="",buttons) {
					const title=(node.name||'Storage Admin')+' '+titleSuffix;
					const float=$('<div></div>');
					float.appendTo('body')
					.html(html)
					.dialog({
 						modal: true, title: title, zIndex: 10000, autoOpen: true,
						width: 'auto', resizable: true,"min-width": (title.length+5) + "px",
						close: function (event, ui) {$(this).remove();},
						buttons:buttons
					});
					return float;
				}
				
				function sendCommand(element,action,data) {
					const nodeName="Storage Admin";
					$(element).dialog("close");
					$[data?"post":"get"]( "storageAdmin/"+node.id+"/"+action,data)
					.done(function(json) {
					  	RED.notify(node._(nodeName+" signal success",{label:label}),{type:"success",id:"Load Injector"});
	//				  	if(action=="details"){
	//				  		listTopic(node,json,float("Details"))
	//					}
					}).fail(function( jqXHR, textStatus, error ) {
						if(jqXHR.status === 404) RED.notify(node._(nodeName+" signal not deployed"),"error");
						else if(jqXHR.status === 500) RED.notify(node._(nodeName+" signal inject failed with "+(textStatus||"error")+" "+(jqXHR.responseText||error)),"error");
						else if(jqXHR.status === 0)	RED.notify(node._(nodeName+" signal no response"),"error");
				   		else RED.notify(node._(nodeName+" signal unexpected status:"+jqXHR.status+" message:"+textStatus+" "+error),"error");
					});
				}
				const buttons={
						close:function(){sendCommand(this,"closeFile")},
						open:function(){sendCommand(this,"openFile")},
						"set Available":function(){sendCommand(this,"setAvailable")},
						"set Unavailable":function(){sendCommand(this,"setUnavailable")}
				}
				$('<div></div>').appendTo('body').html('<div>Choose Action</div>')
  				.dialog({
	  				modal: true, title: (node.name||'Storagae Admin') + '    ', zIndex: 10000, autoOpen: true,
   					width: 'auto', resizable: false,
					buttons: buttons,
					close: function (event, ui) {
						$(this).remove();
					}
				});
			}
		}
	});
</script>

<script type="text/x-red" data-template-name="Storage Admin">

	<div class="form-row">
		<label for="node-input-name"><i class="fa fa-tag"></i> Name </label>
		<input type="text" id="node-input-name" placeholder="Name">
	</div>
	<div class="form-row">
		<label for="node-input-storageDefinition"><i class="fa fa-list-ul"></i> Storage </label>
		<input type="text" id="node-input-storageDefinition">
  	</div>
	<div id="node-inputDynamicBase"/>
</script>

<script type="text/x-red" data-help-name="Storage Admin">
	<p>
	Storage Admin
	</p>
	<h3>Inputs</h3>
	<dl class="message-properties">
		<dt>msg <span class="property-type">topic</span></dt>
		<dd>incoming message with topic</dd>
		<dt>msg <span class="property-type">payload</span></dt>
		<dd></dd>
	</dl>
</script>